#ifndef MSP_GL_TEXTURING_H_
#define MSP_GL_TEXTURING_H_

#include <vector>
#include "bindable.h"

namespace Msp {
namespace GL {

class Texture;

class Texturing: public Bindable<Texturing>
{
private:
	std::vector<const Texture *> attachments;

	static bool legacy_used;

public:
	~Texturing();

	void attach(unsigned, const Texture &);
	void detach(unsigned);
private:
	void set_attachment(unsigned, const Texture *);
public:
	const Texture *get_attached_texture(unsigned) const;

private:
	void bind_attachment(unsigned, bool) const;

	static void unbind_attachment(unsigned);

public:
	void bind(bool = true) const;

	static void unbind();
};

} // namespace GL
} // namespace Msp;

#endif
